
package de.ivu.elect.was.exchange.ergebnis.eml;

import java.util.Collections;
import java.util.List;

import javax.annotation.Nullable;
import javax.inject.Inject;

import de.ivu.elect.business.datei.entity.FileType;
import de.ivu.elect.business.ergebnis.control.ErgebnisExportContext;
import de.ivu.elect.business.ergebnis.control.ErgebnisExportObject;
import de.ivu.elect.business.exchange.control.FileFormat;
import de.ivu.elect.business.gebietsbaum.boundary.WahldurchfuehrungsgebietDAO;
import de.ivu.elect.business.gebietsbaum.entity.GebietPK;
import de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet;
import de.ivu.elect.business.wahl.entity.Wahl;

public class Eml510cCSBErgebnisExportMapper extends Abstract510ErgebnisExportMapper {

  private static final long serialVersionUID = 1L;

  public static final FileFormat FILE_FORMAT = new FileFormat("eml.510c.backup.file.format", FileType.ZIP);

  @Inject
  private transient WahldurchfuehrungsgebietDAO wahldurchfuehrungsgebietDAO;

  public Eml510cCSBErgebnisExportMapper() {
    super();
  }

  @Override
  protected boolean isWahlebenePassend(Wahl wahl) {
    return super.isWahlebenePassend(wahl) && !isHSB(wahl);
  }

  @Override
  protected String getEmlId() {
    return "510c";
  }

  @Override
  public FileFormat getFileFormat() {
    return FILE_FORMAT;
  }

  @Override
  public boolean isSignEml(Wahl wahl) {
    return false; // nicht notwendig siehe https://confluence.ivu.de/pages/viewpage.action?spaceKey=VAPP&title=EML-Import+validation
  }

  @Override
  protected boolean isPsbNotwendig() {
    return false;
  }

  @Override
  protected boolean isHsbNotwendig() {
    return false;
  }

  @Override
  protected boolean isCsbNotwendig() {
    return true;
  }

  @Override
  protected boolean isGebietAuswahlNotwendig() {
    return true;
  }

  @Override
  protected boolean isErfassungsgebietAuswahlNotwendig() {
    return true;
  }

  @Override
  protected boolean isErgebnisNotwendig() {
    return false; // jederzeit möglich
  }

  @Override
  protected List<Wahldurchfuehrungsgebiet> bestimmeReportingUnitGebiete(ErgebnisExportObject ergebnisExportObject, ErgebnisExportContext context) {
    return Collections.emptyList();
  }

  @Nullable
  @Override
  protected Wahldurchfuehrungsgebiet bestimmeTotalVotesGebiet(ErgebnisExportObject ergebnisExportObject, ErgebnisExportContext context) {
    GebietPK gebietPK = getAusgewaehltesGebietPK(context);

    if (gebietPK == null) {
      return null;
    }
    return wahldurchfuehrungsgebietDAO.findByPrimaryKey(gebietPK);
  }

  @Nullable
  @Override
  protected Wahldurchfuehrungsgebiet bestimmeGebietFuerDaten(ErgebnisExportObject ergebnisExportObject, ErgebnisExportContext context) {
    return bestimmeTotalVotesGebiet(ergebnisExportObject, context);
  }

  @Override
  protected String getAuthorityIdPrefix(ErgebnisExportObject ergebnisExportObject) {
    return "";
  }

  @Override
  protected String createdByAuthorityIdPrefix(ErgebnisExportObject ergebnisExportObject) {
    return "CSB";
  }

}
